/*
        LDR ToneMapper

        Copyright (C) 2009 Nasca Octavian Paul
        Author: Nasca Octavian Paul

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef IMAGE_WRAPPER_H
#define IMAGE_WRAPPER_H
#include <stdlib.h>

class ImageWrapper{
	public:
		ImageWrapper();
		~ImageWrapper();
		static void init();
		static void deinit();
		bool load(const char *filename);
		bool save(const char *filename);
		int getSizeX(){
			return sizex;
		};
		int getSizeY(){
			return sizey;
		};
		bool isValid(){
			return (imgdata!=NULL);
		};
		unsigned char *getData(){
			return imgdata;
		};
	private:
		static bool inited;
		void *info;
		unsigned char *imgdata;
		int sizex,sizey;
};


#endif


