/*
        LDR ToneMapper

        Copyright (C) 2009 Nasca Octavian Paul
        Author: Nasca Octavian Paul

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include "Process.h"
#include "ImageWrapper.h"

bool process_8bit_file(const char *input_filename, const char *output_filename, ToneMappingBase *tonemap){
	tonemap->set_preview_zoom(1.0);
	//load the image
	ImageWrapper img;
	if (!img.load(input_filename)) return false;
	

	int sizex=img.getSizeX();
	int sizey=img.getSizeY();
	

	//load the image into the internal RGB format
	if (!img.load(input_filename)) return false;;
	tonemap->process_8bit_rgb_image(img.getData(),sizex,sizey);
	img.save(output_filename);	

	return true;
};


