/*
        LDR ToneMapper

        Copyright (C) 2009 Nasca Octavian Paul
        Author: Nasca Octavian Paul

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include <stdio.h>
#include "ToneMapping/ToneMappingInt.h"
#include "ToneMapping/ToneMappingFloat.h"
#include "Process.h"

int main(int argc, char *argv[]){
	if (argc!=4){
		fprintf(stderr,"%s","\nLDR ToneMapping - Copyright (c) 2009 Nasca Octavian Paul\n");
		fprintf(stderr,"%s","This program is free software (GNU GPL v.2 or later) and \n  it comes with ABSOLUTELY NO WARRANTY.\n\n");     
		printf("Usage: ./tonemapping   parameters.tnp   input_image    output_image\n");
		printf("...where parameters.tnp is the parameter file saved by tonemapping_gui\n\n");
		return 0;
	};
	char *parameters_file=argv[1];
	char *input_file=argv[2];
	char *output_file=argv[3];

	ToneMappingParameters par;
	if (!par.load_parameters(parameters_file)){
		printf("Error: Could not load parameters file: %s \n",parameters_file);
		return 1;
	};

	ToneMappingBase *tonemapping;
	if (par.info_fast_mode) tonemapping=new ToneMappingInt();
		else tonemapping=new ToneMappingFloat();
	tonemapping->apply_parameters(par);
	if (!process_8bit_file(input_file,output_file,tonemapping)){
		printf("Error: Could not tonemap file : %s \n",output_file);
		return 1;
	};

	delete tonemapping;	
	return 0;
};



